CDECK  ID>, CHDTHR.
*CMZ :-        -17/07/03  18.11.30  by  Peter Richardson
*-- Author :    Bryan Webber
C-----------------------------------------------------------------------
      SUBROUTINE CHDTHR(P0,P1,P2,P3,OKDEC)
C-----------------------------------------------------------------------
C     GENERATES THREE-BODY DECAY 0->1+2+3 DISTRIBUTED
C     ACCORDING TO PHASE SPACE * WEIGHT
C     (extracted from HERWIG)
C-----------------------------------------------------------------------
      IMPLICIT NONE
      DOUBLE PRECISION CHRGEN,CHRUNI,A,B,C,D,AA,BB,CC,DD,EE,FF,PP,QQ,WW,
     & RR,PCM1,PC23,P0(5),P1(5),P2(5),P3(5),P23(5),TWO,ONE
      EXTERNAL CHRGEN,CHRUNI
      PARAMETER (ONE=1.0D0,TWO=2.D0)
      INTEGER MTRY,NTRY
      PARAMETER (MTRY=1000000)
      LOGICAL OKDEC
      OKDEC=.FALSE.
      A=P0(5)+P1(5)
      B=P0(5)-P1(5)
      C=P2(5)+P3(5)
      IF (B.LT.C) RETURN
      D=ABS(P2(5)-P3(5))
      AA=A*A
      BB=B*B
      CC=C*C
      DD=D*D
      EE=(B-C)*(A-D)
      A=0.5D0*(AA+BB)
      B=0.5D0*(CC+DD)
      C=4.0D0/(A-B)**2
      NTRY=0
C
C  CHOOSE MASS OF SUBSYSTEM 23 WITH PRESCRIBED DISTRIBUTION
C
   10 FF=CHRUNI(0,BB,CC)
      NTRY=NTRY+1
      IF (NTRY.GT.MTRY) RETURN
      PP=(AA-FF)*(BB-FF)
      QQ=(CC-FF)*(DD-FF)
      WW=ONE
      RR=EE*FF*CHRGEN(0)
      IF (PP*QQ*WW.LT.RR*RR) GOTO 10
C
C  FF IS MASS SQUARED OF SUBSYSTEM 23.
C
C  DO 2-BODY DECAYS 0->1+23, 23->2+3
C
      P23(5)=SQRT(FF)
      PCM1=SQRT(PP)*0.5D0/P0(5)
      PC23=SQRT(QQ)*0.5D0/P23(5)
      CALL CHDTWO(P0,P1,P23,PCM1,TWO,.TRUE.)
      CALL CHDTWO(P23,P2,P3,PC23,TWO,.TRUE.)
      OKDEC=.TRUE.
      END
